﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;

	public class Progresser extends Sprite
	{
		private var drawer:Sprite;
		private var data:BitmapData;
		private var background:Bitmap;
		
		//SETTINGS
		private var stepper:Number = 3;
		private var separator:Number = 3;
		private var counter:Number;
		private var line:Number;
		
		public function Progresser()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			addEventListener(Event.ENTER_FRAME, draw);
			stage.addEventListener(MouseEvent.CLICK,clickHandler);
		}
		
		private function clickHandler(e:MouseEvent):void
		{
			removeChildAt(0);
			data = null;
		}
		
		private function fullhandler(e:FullScreenEvent):void
		{
			removeChildAt(0);
			data = null;
		}
		
		private function setup():void
		{
			data = new BitmapData(stage.stageWidth,stage.stageHeight,true,0x000000);
			background = new Bitmap(data);
			addChildAt(background,0);
			drawer = new Sprite();
			counter = 0;
			line = 0;
		}
		
		private function draw(e:Event):void
		{
			if(data == null){
				setup();
			}
			counter++;
			drawer.graphics.clear();
			var _height:Number = mouseX/2;
			var _width:Number = mouseY/3;
			var posx:Number = stage.stageWidth-_width;
			var posy:Number = line*_height;
			
			//dessiner progressivement par ligne un rectangle avec alpha dépendant du séparator
			drawer.graphics.beginFill(Math.random()*0xffffff,1/separator);
			drawer.graphics.drawRect(mouseX,mouseY,_width,_height);
			drawer.graphics.endFill();
			
			//dessiner dans le bmpdt
			data.draw(drawer);
			
			//condition
			if(_width >= stage.stageWidth){
				counter = 0;
				line++;
			}
			if(posy>=stage.stageHeight){
				line = 0;
			}
		}
		
	}
}